/**
 * @name Store Locator Plus® Power User Interface
 * @version version 5.11.2
 * @author Lance Cleveland
 * @preserve
 * @see {@link https://storelocatorplus.com|Store Locator Plus®}
 * @see {@link https://lance.bio|Lance Cleveland}
 * @fileoverview
 * Part of the Store Locator Plus® main plugin for the WordPress application framework that runs the
 * Store Locator Plus® SaaS map location platform
 */
slp_Filter=function(id){let callbacks,topic;topic=id&&slp.topics[id];if(!topic){if(typeof jQuery.Callbacks!=="undefined"){callbacks=jQuery.Callbacks();topic={publish:callbacks.fire,subscribe:callbacks.add,unsubscribe:callbacks.remove}}else{slp.log("jQuery 1.7.0+ required, "+jQuery.fn.version+" used instead.");topic={publish:function(data){return data}}}if(id){slp.topics[id]=topic}}return topic};slp={generic_object:{a:document.createElement("a")},important_object:{address_div:{},address_input:{},find_button:{},map:{},results:{},search_form:{},slp_div:{}},topics:{},sensor:{},filter:function(filterID){slp_Filter(filterID)},init:function(){if(typeof slplus!=="undefined"){if(window.location.protocol!==slplus.ajaxurl.substring(0,slplus.ajaxurl.indexOf(":")+1)){slplus.ajaxurl=slplus.ajaxurl.replace(slplus.ajaxurl.substring(0,slplus.ajaxurl.indexOf(":")+1),window.location.protocol)}}const radioCheck=/radio|checkbox/i,keyBreaker=/[^\[\]]+/g,numberMatcher=/^[\-+]?[0-9]*\.?[0-9]+([eE][\-+]?[0-9]+)?$/;const isNumber=value=>{if(typeof value==="number"){return true}if(typeof value!=="string"){return false}return value.match(numberMatcher)};jQuery.fn.extend({formParams:function(convert){if(this[0].nodeName.toLowerCase()==="form"&&this[0].elements){return jQuery(jQuery.makeArray(this[0].elements)).getParams(convert)}return jQuery("input[name], textarea[name], select[name]",this[0]).getParams(convert)},getParams:function(convert){var data={},current;convert=convert===undefined?true:convert;this.each(function(){var el=this,type=el.type&&el.type.toLowerCase();if(type==="submit"||!el.name){return}var key=el.name,value=jQuery.data(el,"value")||jQuery.fn.val.call([el]),isRadioCheck=radioCheck.test(el.type),parts=key.match(keyBreaker),write=!isRadioCheck||!!el.checked,lastPart;if(convert){if(isNumber(value)){value=parseFloat(value)}else if(value==="true"||value==="false"){value=Boolean(value)}}current=data;for(var i=0;i<parts.length-1;i++){if(!current[parts[i]]){current[parts[i]]={}}current=current[parts[i]]}lastPart=parts[parts.length-1];if(lastPart in current&&type==="checkbox"){if(!Array.isArray(current[lastPart])){current[lastPart]=current[lastPart]===undefined?[]:[current[lastPart]]}if(write){current[lastPart].push(value)}}else if(write||!current[lastPart]){current[lastPart]=write?value:undefined}});return data}})},run:function(){slp_Filter("ready").publish(this);slp.init();slp.start_map()},log:function(message){if(window.console){console.log(message)}},notification:function(){this.inline=function(header,message){return'<div class="container fluid grid-list-lg" style="min-height: 0px;">'+'<div class="layout row wrap">'+'<div class="flex xs12">'+'<div class="white--text card blue-grey darken-2" data-ripple="false" style="height: auto;">'+'<div class="card__title card__title--primary">'+'<div class="headline">'+header+"</div>"+"<div>"+message+"</div>"+"</div>"+"</div>"+"</div>"+"</div>"+"</div>"}},setup_helpers:function(){slp.important_object={address_row:jQuery("#addy_in_address"),address_input:jQuery("#addressInput"),map:jQuery("#map"),results:jQuery("#map_sidebar"),search_form:jQuery("#searchForm"),slp_div:jQuery("div.store_locator_plus")};String.prototype.replace_shortcodes=function(){var args=arguments;var currentLocation=args[0];var shortcode_complex_regex=/\[(\w+)\s+([\w\.]+)\s*(\w*)(?:[\s="]*)([\w|\.]*)(?:[\s"]*)\s*(\w*)(?:[\s="]*)([\w|\.]*)(?:[\s"]*)\]/g;return this.replace(shortcode_complex_regex,function(match,shortcode,attribute,modifier,modarg,modifier2,modarg2){let field_name="",value="",output="";switch(shortcode){case"slp_location":if(attribute==="latitude"){attribute="lat"}if(attribute==="longitude"){attribute="lng"}value="";field_name="";if(currentLocation[attribute]){value=currentLocation[attribute];field_name=attribute}else if(attribute.indexOf(".")>1){var dot_notation_regex=/(\w+)/gi;var data_parts=attribute.match(dot_notation_regex);var marker_array_name=data_parts[0];if(!currentLocation[marker_array_name]){return""}var marker_array_field=data_parts[1];value=currentLocation[marker_array_name][marker_array_field];if(!value){return""}field_name=marker_array_name+"_"+marker_array_field}else{return""}output=value.shortcode_modifier({modifier:modifier,modarg:modarg,field_name:field_name,marker:currentLocation});if(modifier2){output=output.shortcode_modifier({modifier:modifier2,modarg:modarg2,field_name:field_name,marker:currentLocation})}return output;case"slp_option":var options=slplus.options;slp_Filter("replace_shortcodes_options").publish(options);if(attribute==="name"){attribute=modarg;modarg=""}if(!options[attribute]){jQuery.ajax({url:slplus.rest_url+"options/"+attribute,dataType:"json",success:function(json_data){var response;if(typeof json_data==="string"){response=jQuery.parseJSON(json_data)}else{response=json_data}options[attribute]=response.value;output=slp.shortcode_output(currentLocation,field_name,options[attribute],modifier,modarg,modifier2,modarg2);jQuery('span[data-option="'+attribute+'"][data-locationid="'+currentLocation.id+'"]').html(output).show()},error:function(){return""}});return'<span data-option="'+attribute+'" data-locationid="'+currentLocation.id+'"></span>'}else{return slp.shortcode_output(currentLocation,field_name,options[attribute],modifier,modarg,modifier2,modarg2)}case"html":output="";switch(attribute){case"br":output="<br/>";break;case"closing_anchor":output="</a>";break;default:break}output=output.shortcode_modifier({modifier:modifier,modarg:modarg,field_name:"raw_html",marker:currentLocation});if(modifier2){output=output.shortcode_modifier({modifier:modifier2,modarg:modarg2,field_name:"raw_html",marker:currentLocation})}return output;case"slp_addon":return"";default:return match+" not supported"}})};String.prototype.shortcode_modifier=function(){var args=arguments;var full_mod=args[0];var modifier=full_mod.modifier;var modarg=full_mod.modarg;var field_name=full_mod.field_name;var raw_output=true;var get_marker_data=function(element,marker){var split_element=element.split(".");if(split_element.length===1){if(marker[element])return marker[element];return marker.data[element]}else{return marker.data[split_element[1]]}};if(field_name==="hours"){raw_output=false}var value=this;var prefix="";var suffix="";if(modifier){switch(modifier){case"ifset":if(!get_marker_data(modarg,full_mod.marker)){return""}break;case"ifnotset":if(get_marker_data(modarg,full_mod.marker)){return""}break;case"suffix":switch(modarg){case"br":suffix="<br/>";break;case"comma":suffix=",";break;case"comma_space":suffix=", ";break;case"space":suffix=" ";break;default:break}break;case"wrap":switch(modarg){case"directions":prefix='<a href="https://'+slplus.options.map_domain+"/maps?saddr="+encodeURIComponent(cslmap.getSearchAddress(cslmap.address))+"&daddr="+encodeURIComponent(full_mod.marker["fullAddress"])+'" target="_blank" class="storelocatorlink">';suffix="</a> ";break;case"img":prefix='<img src="';suffix='" class="sl_info_bubble_main_image">';break;case"mailto":prefix='<a href="mailto:';suffix='" target="_blank" class="storelocatorlink">';break;case"website":prefix='<a href="';suffix='" '+'target="'+(slplus.options.use_same_window!=="0"?"_self":"_blank")+'" '+'id="slp_marker_website" '+'class="storelocatorlink" '+">";break;case"fullspan":prefix='<span class="results_line location_'+field_name+'">';suffix="</span>";break;default:break}break;case"format":switch(modarg){case"decimal1":value=parseFloat(value).toFixed(1);break;case"decimal2":value=parseFloat(value).toFixed(2);break;case"sanitize":value=value.replace(/\W/g,"_");break;case"text":value=jQuery("<div/>").html(value).text();break;default:break}break;case"raw":raw_output=true;break;default:break}}var newOutput=raw_output?value:jQuery("<div/>").html(value).text();return prefix+newOutput+suffix}},setup_map:function(){cslmap=new slp_Map;slp_Filter("slp_map_ready").publish(cslmap);if(!slplus.options.use_sensor){cslmap.usingSensor=false;if(slplus.options.id_addr!=null){cslmap.address=slplus.options.id_addr}if(!cslmap.address&&slplus.options.map_center){cslmap.address=slplus.options.map_center}if(slplus.options.map_center_lat&&slplus.options.map_center_lng){if(typeof cslmap.build_map==="function"){var map_center=new google.maps.LatLng(slplus.options.map_center_lat,slplus.options.map_center_lng);cslmap.build_map(map_center)}}else{cslmap.doGeocode()}}},shortcode_output:function(currentLocation,field_name,value,modifier,modarg,modifier2,modarg2){var output;output=value.shortcode_modifier({modifier:modifier,modarg:modarg,field_name:field_name,marker:currentLocation});if(modifier2){output=output.shortcode_modifier({modifier:modifier2,modarg:modarg2,field_name:field_name,marker:currentLocation})}return output},start_map:function(){if(jQuery("#map").length){if(typeof slplus!=="undefined"){if(typeof google!=="undefined"){slp.setup_helpers();slp.setup_map();slp.subscriptions.initalize();slplus.notifications=new slp.notification}else{jQuery("#map").html("Looks like you turned off Store Locator Plus® Maps under General Settings but need them here.")}}else{jQuery("#map").html("Store Locator Plus® did not initialize properly.")}}},subscriptions:{},geocoder:{geocode:function(request,callback){jQuery.getJSON(encodeURI(slplus.rest_url+"geocode/"+slplus.apikey+"/"+request.region+"/"+request.address)).done(function(resp){if(resp.error_message){var ref_phrase=", with referer";if(resp.error_message.includes(ref_phrase)){resp.error_message=resp.error_message.substring(0,resp.error_message.indexOf(ref_phrase))}}else{resp.error_message=""}callback(resp.results,resp.status,resp.error_message)}).fail(function(resp){callback(resp,google.maps.GeocoderStatus.ERROR)})}},option:{get_from_server:function(option_name,callback){if(typeof slplus.shortcode_attributes[option_name]!=="undefined"){callback({value:slplus.shortcode_attributes[option_name]});return}jQuery.getJSON(encodeURI(slplus.rest_url+"options/filtered/"+option_name)).done(function(resp){if(resp.error_message){console.log(resp.error_message)}else{resp.error_message=""}callback(resp)}).fail(function(){console.log("get_from_server failed")})}}};slp.subscriptions=function(){var loading_class="loading_locations";this.initialize=function(){slp_Filter("load_marker_action").subscribe(show_locations_processing);slp_Filter("location_search_responded").subscribe(remove_locations_processing)};this.show_locations_processing=function(){slp.important_object.slp_div.addClass(loading_class)};this.remove_locations_processing=function(){slp.important_object.slp_div.removeClass(loading_class)};return{initalize:initialize}}();function gm_authFailure(){const html=slplus.notifications.inline(slplus.messages.slp_system_message,slplus.messages.no_api_key);jQuery("#map").prepend(html)}slp_Marker=function(map,title,position,markerImage,location_id){this.__map=map;this.__title=title;this.__position=position;this.__gmarker=null;this.__markerImage=markerImage;this.__location_id=location_id;this.__init=function(){slp_Filter("marker").publish(this);this.__gmarker=new google.maps.Marker({position:this.__position,map:this.__map.gmap,title:this.__title,icon:this.protocol_tweaker(this.__markerImage)})};this.protocol_tweaker=function(icon_url){slp.generic_object.a.href=icon_url;if(slp.generic_object.a.hostname!==window.location.hostname)return icon_url;slp.generic_object.a.protocol=window.location.protocol;return slp.generic_object.a.href};this.__init()};slp_Map=function(){const _this=this;this.auto_bound=true;this.infowindow=new google.maps.InfoWindow;this.geocoder=slp.geocoder;this.geocoder_request={};this.gmap=null;this.map_hidden=true;this.default_radius="40000";this.address=null;this.draggable=true;this.markers=null;this.usingSensor=false;this.mapHomeIconUrl=null;this.mapType=null;this.options=null;this.centerMarker=null;this.active_marker=null;this.marker=null;this.bounds=null;this.homePoint=null;this.lastCenter=null;this.lastRadius=null;this.latest_response=null;this.search_options=null;this.__init=function(){if(typeof slplus==="undefined"){var html=slplus.notifications.inline(slplus.messages.slp_system_message,slplus.messages.script_not_loaded);jQuery(".store_locator_plus").prepend(html);return}this.mapType=slplus.options.map_type;this.mapHomeIconUrl=slplus.options.map_home_icon;var addressInput=this.getSearchAddress();if(typeof addressInput==="undefined"){this.address=slplus.options.map_center}else{this.address=addressInput}google.maps.event.addListener(this.infowindow,"domready",function(){jQuery(".slp_info_bubble").parent().addClass("slp_bubble_level_1");jQuery(".slp_info_bubble").parent().parent().addClass("slp_bubble_level_2");jQuery(".slp_info_bubble").parent().parent().parent().addClass("slp_bubble_level_3");jQuery(".slp_info_bubble").parent().parent().parent().parent().addClass("slp_bubble_level_4");jQuery(".slp_bubble_level_4").children("div:first-child").addClass("slp_bubble_elements");jQuery(".slp_bubble_level_4").children("div:last-child").addClass("slp_bubble_closer");jQuery(".slp_bubble_elements").children("div:first-child").addClass("slp_bubble_tail_behind");jQuery(".slp_bubble_elements").children("div:nth-child(2)").addClass("slp_bubble_behind");jQuery(".slp_bubble_elements").children("div:nth-child(3)").addClass("slp_bubble_tail_pieces");jQuery(".slp_bubble_tail_pieces").children("div:first-child").addClass("slp_bubble_left_tail");jQuery(".slp_bubble_left_tail").children("div:first-child").addClass("slp_bubble_left_tail_back");jQuery(".slp_bubble_tail_pieces").children("div:last-child").addClass("slp_bubble_right_tail");jQuery(".slp_bubble_right_tail").children("div:first-child").addClass("slp_bubble_right_tail_back");jQuery(".slp_bubble_elements").children("div:nth-child(4)").addClass("slp_bubble_background");jQuery(".slp_info_bubble").parent().parent().parent().parent().parent().addClass("slp_bubble_level_5");jQuery(".slp_info_bubble").parent().parent().parent().parent().parent().parent().addClass("slp_bubble_level_6")})};if(typeof slplus.options.hide_map==="undefined"||slplus.options.hide_map!=="1"){this.build_map=function(center,map_div_id){if(!map_div_id){map_div_id=document.getElementById("map")}if(this.gmap!==null){return}this.options={center:center,mapTypeId:this.mapType,minZoom:1,zoom:parseInt(slplus.options.zoom_level)};if(slplus.options.google_map_style){jQuery.extend(this.options,{styles:JSON.parse(slplus.options.google_map_style)})}slp_Filter("map_options").publish(this.options);this.gmap=new google.maps.Map(map_div_id,this.options);google.maps.event.addListener(this.gmap,"bounds_changed",function(){_this.__waitForTileLoad.call(_this)});if(this.show_home_marker()){this.homePoint=center;this.addMarkerAtCenter()}if(slplus.options.immediately_show_locations!=="0"){var radius=null;slplus.options.initial_radius=slplus.options.initial_radius.replace(/\D/g,"");if(/^[0-9]+$/.test(slplus.options.initial_radius)){radius=slplus.options.initial_radius}this.search_options=null;this.load_markers(center,radius)}slp_Filter("map_built").publish()}}this.set_active_marker_to_location=function(location_id){jQuery.each(this.markers,function(index,marker){if(marker.__location_id===location_id){cslmap.active_marker=marker;return false}})};this.show_home_marker=function(){return this.usingSensor||slplus.options.immediately_show_locations!=="0"&&slplus.options.no_homeicon_at_start!=="1"};this.__waitForTileLoad=function(){if(this.__tilesLoaded===null){this.__tilesLoaded=google.maps.event.addListener(this.gmap,"tilesloaded",function(){_this.__tilesAreLoaded.call(_this)})}};this.__tilesAreLoaded=function(){jQuery("#map").find("img").css({"max-width":"none"});google.maps.event.removeListener(this.__tilesLoaded);this.__tilesLoaded=null};this.addMarkerAtCenter=function(){if(this.centerMarker){this.centerMarker.__gmarker.setMap(null)}if(this.homePoint){this.centerMarker=new slp_Marker(this,"",this.homePoint,this.mapHomeIconUrl,0)}};this.clearMarkers=function(){if(this.markers){for(markerNumber in this.markers){if(typeof this.markers[markerNumber]!=="undefined"){if(typeof this.markers[markerNumber].__gmarker!=="undefined"){this.markers[markerNumber].__gmarker.setMap(null)}}}this.markers.length=0;if(!this.saneValue("addressInput","")){this.centerMarker=null;this.homePoint=null}}};this.putMarkers=function(markerListNatural){var location_data,markerCount,sidebar;this.markers=[];sidebar=document.getElementById("map_sidebar");sidebar.innerHTML="";markerCount=markerListNatural?markerListNatural.length:0;if(markerCount===0){if(this.homePoint&&this.auto_bound){this.gmap.panTo(this.homePoint)}slp.option.get_from_server("message_no_results",function(response){if(response.value){document.getElementById("map_sidebar").innerHTML='<div class="no_results_found"><h2>'+response.value+"</h2></div>"}else{console.log("No results found.  No message set.")}})}else{var results_html={content:"",insert_rows_at:"#map_sidebar"};slp_Filter("location_results_header").publish(results_html);if(results_html.content.trim()){slp.important_object.results.append(results_html.content)}var bounds=new google.maps.LatLngBounds;if(this.homePoint){bounds.extend(this.homePoint)}for(var markerNumber=0;markerNumber<markerCount;++markerNumber){if(markerListNatural[markerNumber]==null){slp.log("SLP marker number "+markerNumber+" is null. ");continue}if(typeof markerListNatural[markerNumber].data!=="undefined"){location_data=markerListNatural[markerNumber].data}else{location_data=markerListNatural[markerNumber]}if(!markerListNatural[markerNumber].position){markerListNatural[markerNumber].position=new google.maps.LatLng(markerListNatural[markerNumber].lat,markerListNatural[markerNumber].lng)}bounds.extend(markerListNatural[markerNumber].position);this.markers.push(new slp_Marker(this,location_data.sl_store,markerListNatural[markerNumber].position,_this.is_valid_icon(markerListNatural[markerNumber].icon)?markerListNatural[markerNumber].icon:slplus.options.map_end_icon,location_data.sl_id));google.maps.event.addListener(this.markers[markerNumber].__gmarker,"click",function(infoData,marker){return function(){_this.show_map_bubble.call(_this,infoData,marker)}}(markerListNatural[markerNumber],this.markers[markerNumber]));if(sidebar){jQuery(results_html.insert_rows_at).append(this.createSidebar(markerListNatural[markerNumber]));jQuery(results_html.insert_rows_at+" span:empty").hide();jQuery("#slp_results_wrapper_"+markerListNatural[markerNumber].id).on("click",null,{info:markerListNatural[markerNumber],marker:this.markers[markerNumber]},_this.handle_location_result_click)}}if(this.gmap){this.bounds=bounds;if(this.auto_bound){this.gmap.fitBounds(this.bounds);if(slplus.options.no_autozoom==="1"){this.gmap.setZoom(parseInt(slplus.options.zoom_level))}else{var current_zoom=this.gmap.getZoom();var zoom_tweak=parseInt(slplus.options.zoom_tweak);var new_zoom=current_zoom-zoom_tweak;if(markerCount<2){new_zoom=Math.min(new_zoom,15)}this.gmap.setZoom(new_zoom)}}}}slp.important_object.results.trigger("contentchanged")};this.handle_location_result_click=function(event){jQuery(this).trigger("result_clicked",event);_this.show_map_bubble(event.data.info,event.data.marker)};this.is_valid_icon=function(icon){return icon!==null&&typeof icon!=="undefined"&&icon.length>4};this.show_map_bubble=function(infoData,marker){this.options={show_bubble:slplus.options.hide_bubble!=="1"};slp_Filter("map_options").publish(this.options);if(this.options.show_bubble){this.infowindow.setContent(this.createMarkerContent(infoData));this.infowindow.open(this.gmap,marker.__gmarker)}};this.process_geocode_response=function(results,status,message){if(status===google.maps.GeocoderStatus.OK&&results.length>0){var geocode_results={all:results,request:_this.geocoder_request,best:results[0]};slp_Filter("geocode_results").publish(geocode_results);if(typeof geocode_results.best.geometry.location!==google.maps.LatLng){geocode_results.best.geometry.location=new google.maps.LatLng(geocode_results.best.geometry.location.lat,geocode_results.best.geometry.location.lng)}if(_this.gmap===null){if(typeof _this.build_map==="function"){_this.build_map(geocode_results.best.geometry.location)}}else{_this.homePoint=geocode_results.best.geometry.location;_this.addMarkerAtCenter();_this.load_markers(geocode_results.best.geometry.location,_this.saneValue("radiusSelect","40000"))}}else{if(_this.gmap===null){if(typeof _this.build_map==="function"){slp.log("Map set to fallback lat/lng: "+slplus.options.map_center_lat+" , "+slplus.options.map_center_lng);_this.homePoint=new google.maps.LatLng(slplus.options.map_center_lat,slplus.options.map_center_lng);_this.build_map(_this.homePoint);_this.addMarkerAtCenter()}}else{slp.option.get_from_server("message_bad_address",function(response){if(response.value){document.getElementById("map_sidebar").innerHTML=response.value+"<br/>"+'<p class="geocode_message">'+"Google Maps API error: <br/>"+message+"<br/>"+'Tired of fighting the Google Maps API?  Try <a href="https://storelocatorplus.com/">our SaaS offering</a>.';"</p>"}else{console.log("Bad address.  No message set.")}});_this.clearMarkers()}}};this.doGeocode=function(){_this.geocoder_request["address"]=_this.address;_this.geocoder_request["region"]=typeof slplus.options.map_region!=="undefined"&&slplus.options.map_region?slplus.options.map_region:"us";if(slplus.options.searchnear==="currentmap"){if(_this.gmap){_this.geocoder_request["bounds"]=_this.gmap.getBounds()}}slp_Filter("geocoder_request").publish(_this.geocoder_request);_this.geocoder.geocode(_this.geocoder_request,_this.process_geocode_response)};this.__createAddress=function(aMarker){var address="";if(aMarker.address!==""){address+=aMarker.address}if(aMarker.address2!==""){address+=", "+aMarker.address2}if(aMarker.city!==""){address+=", "+aMarker.city}if(aMarker.state!==""){address+=", "+aMarker.state}if(aMarker.zip!==""){address+=", "+aMarker.zip}if(aMarker.country!==""){address+=", "+aMarker.country}return address};this.createMarkerContent=function(thisMarker){thisMarker["fullAddress"]=this.__createAddress(thisMarker);return slplus.options.bubblelayout.replace_shortcodes(thisMarker)};const getImportantSearchOptions=()=>{if(this.search_options===null){const jsonSearchOptions=JSON.parse(JSON.stringify(slplus.options));const importantOptions=["initial_results_returned","max_results_returned","map_center_lat","map_center_lng","active_locations","city","country","distance_unit","ignore_radius","initial_radius","map_domain","map_end_icon","state","territory"];this.search_options={};importantOptions.forEach(key=>{this.search_options[key]=jsonSearchOptions[key]})}return this.search_options};this.getSearchAddress=function(defaultAddress){var searchAddress=jQuery("#addressInput").val();if(!searchAddress){if(typeof cslmap!=="undefined"&&cslmap.usingSensor&&slp.sensor.lat!==0&&slp.sensor.lng!==0){searchAddress=slp.sensor.lat+","+slp.sensor.lng}else{searchAddress=defaultAddress}}return searchAddress};this.saneValue=function(id,defaultValue){let name=document.getElementById(id);if(name===null){name=defaultValue.trim()}else{name=name.value.trim()}return name};this.load_markers=function(center,radius){var action,store_name,tags;if(center===null){center=this.gmap.getCenter()}this.lastCenter=center;this.lastRadius=radius;action={action:"csl_ajax_search",address:this.saneValue("addressInput","no address entered"),formdata:jQuery("#searchForm").serialize(),lat:center.lat(),lng:center.lng(),options:getImportantSearchOptions(),radius:radius};store_name=this.saneValue("nameSearch","");if(store_name!==""){action["store_name"]=store_name}tags=this.saneValue("tag_to_search_for","");if(tags!==""){action["tags"]=tags}slp_Filter("load_marker_action").publish(action);if(slplus.options.immediately_show_locations!=="0"){action.action="csl_ajax_onload";slplus.options.immediately_show_locations="0";this.search_options=null}slp.send_ajax(action,_this.process_ajax_response)};this.process_ajax_response=function(response){valid_response=typeof response.response!=="undefined";if(valid_response){valid_response=response.success}slp_Filter("location_search_responded").publish(response);if(valid_response){cslmap.latest_response=response;cslmap.clearMarkers();slp_Filter("locations_found").publish(response);cslmap.putMarkers(response.response);jQuery("#map").trigger("markers_dropped")}else{if(window.console){slp.log("SLP server did not send back a valid JSONP response.");if(typeof response!=="undefined"){slp.log("Response: "+response)}if(typeof response.message!=="undefined"){var sidebar=document.getElementById("map_sidebar");sidebar.innerHTML=response.message}}}slp_Filter("location_search_processed").publish()};this.searchLocations=function(){var append_this=typeof slplus.options.append_to_search!=="undefined"&&slplus.options.append_to_search?" "+slplus.options.append_to_search.trim():"";var address=this.saneValue("addressInput","")+append_this;this.unhide_map();google.maps.event.trigger(this.gmap,"resize");if(address){this.address=address;this.doGeocode()}else{this.load_markers(null,this.saneValue("radiusSelect","40000"))}};this.createSidebar=function(currentLocation){currentLocation.pro_tags="";if(currentLocation.tags.trim()!==""){var tagclass=currentLocation.tags.replace(/\W/g,"_");currentLocation.pro_tags='<br/><div class="'+tagclass+' slp_result_table_tags"><span class="tagtext">'+currentLocation.tags+"</span></div>"}currentLocation.phone_with_label=currentLocation.phone.trim()!==""?slplus.options["label_phone"]+currentLocation.phone:"";currentLocation.fax_with_label=currentLocation.fax.trim()!==""?slplus.options["label_fax"]+currentLocation.fax:"";var address=this.__createAddress(currentLocation);currentLocation.location_address=encodeURIComponent(address);currentLocation.search_address=encodeURIComponent(this.getSearchAddress(this.address));currentLocation.hours_sanitized=jQuery("<div/>").html(currentLocation.hours).text();var inner_html={content:slplus.options.resultslayout.replace_shortcodes(currentLocation),finished:false};slp_Filter("wrap_location_results").publish(inner_html);if(!inner_html.finished){inner_html.content='<div class="results_wrapper" id="slp_results_wrapper_'+currentLocation.id+'">'+inner_html.content+"</div>"}return inner_html.content};this.unhide_map=function(){if(this.map_hidden){jQuery("#map_box_image").hide();jQuery("#map_box_map").show();this.map_hidden=false}};this.__init()};